#pragma once

#include <memory>
#include <thread>

#pragma warning(disable : 4267)
#include <websocketpp/config/asio_no_tls.hpp>
#include <websocketpp/server.hpp>
#pragma warning(default : 4267)

#include "service.h"

/*
 * Service class for websocket communication
 */
class CCommunicator final : public IService
{
	private:
		// websockepp server
		websocketpp::server<websocketpp::config::asio> mServer;

		// communications thread
		std::unique_ptr<std::thread> mComm_Thread;

	protected:
		// message handler
		void On_Message(websocketpp::connection_hdl hdl, websocketpp::server<websocketpp::config::asio>::message_ptr msg);

		// thread method for websocket acceptor and reactor
		void Thread_Fnc();

	public:
		CCommunicator();
		~CCommunicator();

		// IService interface
		virtual bool Start(size_t nParam) override;
		virtual bool Stop() override;

		// INamed_Service concept
		constexpr static const char* Service_Name = "WebSocket communicator";
};
