<html>
<head>
    <title>SmartCGMS Demo</title>

    <link rel="stylesheet" href="node_modules/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="style.css?ts=<?php time(); ?>" />
    <script src="node_modules/jquery/dist/jquery.min.js"></script>
    <script src="node_modules/chart.js/dist/chart.umd.js"></script>

    <script src="comm.js?ts=<?php time(); ?>"></script>

</head>
<body>

<div class="fixedlogo" style="position: fixed; top: 6px; left: 6px; height: 52px; line-height: 1.05em; display: table; vertical-align: middle;">
    <div style="display: table-cell; vertical-align: middle;"><img src="hp_scgms.png" style="width: 48px; height: 48px; margin-right: 6px;"/></div>
    <div style="display: table-cell; vertical-align: middle;"><span style="font-size: 0.8em;">Powered by <b>SmartCGMS</b></span><br /><span style="font-size: 0.6em;">diabetes.zcu.cz</span></div>
</div>
<div class="fixedbar">
    <a href="#" class="btn-refresh" onclick="location.reload(true);"></a>
    <a href="#" class="btn-info" data-bs-toggle="modal" data-bs-target="#aboutModal"></a>
</div>

<div class="container-fluid text-center nosidepadding">
    <div class="row nosidepadding">
        <div class="col nosidepadding">
            <ul class="nav nav-tabs justify-content-center" id="myTab" role="tablist">
                <li class="nav-item" role="presentation">
                    <button class="nav-link active" id="home-tab" data-bs-toggle="tab" data-bs-target="#home-tab-pane" type="button" role="tab" aria-controls="home-tab-pane" aria-selected="true"><img src="dashboard.png"/></button>
                </li>
                <li class="nav-item" role="presentation">
                    <button class="nav-link" id="carbs-tab" data-bs-toggle="tab" data-bs-target="#carbs-tab-pane" type="button" role="tab" aria-controls="carbs-tab-pane" aria-selected="false"><img src="meals.png"/></button>
                </li>
                <li class="nav-item" role="presentation">
                    <button class="nav-link" id="insulin-tab" data-bs-toggle="tab" data-bs-target="#insulin-tab-pane" type="button" role="tab" aria-controls="insulin-tab-pane" aria-selected="false"><img src="insulin.png"/></button>
                </li>
            </ul>
            <div class="tab-content" id="myTabContent">
                <div class="tab-pane fade show active" id="home-tab-pane" role="tabpanel" aria-labelledby="home-tab" tabindex="0">

                    <div class="row">
                        <div class="col-4 mid">
                            <div class="row"><div class="col"><span class="conn_indicator"></span><span class="conn_desc"></span></div></div>
                            <div class="row"><div class="col"><span class="indicator_title">Interstitial glucose</span></div></div>
                            <div class="row"><div class="col"><span class="cur_glucose large_indicator">??</span><span class="indicator_units"> mmol/L</span></div></div>
                            <div class="row"><div class="col"><span class="indicator_title">Basal insulin rate</span></div></div>
                            <div class="row"><div class="col"><span class="cur_basal large_indicator">??</span><span class="indicator_units"> U/hr</span></div></div>
                            <div class="row"><div class="col"><span class="indicator_title">Water pumps</span></div></div>
                            <div class="row">
                                <div class="col">
                                    1<div class="outer_progress"><div class="inner_progress" id="pump1rate"></div></div>
                                </div>
                                <div class="col">
                                    2<div class="outer_progress"><div class="inner_progress" id="pump0rate"></div></div>
                                </div>
                            </div>
                        </div>
                        <div class="col-8">
                            <canvas id="glucChart" style="width:100%;max-width:700px;height:360px;"></canvas>
                        </div>
                    </div>
                </div>
                <div class="tab-pane fade" id="carbs-tab-pane" role="tabpanel" aria-labelledby="carbs-tab" tabindex="0">

                    <div class="row">
                        <?php
                        
                        function emit_food_block($title, $carbs, $image) {
                            echo '<div class="col foodblock">'.
                                     '<div class="foodimg"><img src="img/'.$image.'"/></div>'.
                                     '<div class="foodtitle">'.$title.'</div>'.
                                     '<div class="carbs">Carbs: '.$carbs.' g</div>'.
                                     '<div class="eatbtnblock"><a class="btn btn-lg btn-primary" href="#" onclick="sendMeal('.$carbs.'); activeTab(\'home-tab\');">Eat</a></div>'.
                                '</div>';
                        }

                        emit_food_block('Banán', 19, 'banan.jpg');
                        emit_food_block('Tatranka', 39, 'tatranka.jpg');
                        emit_food_block('Špagety boloňské', 25, 'spagety.jpg');

                        ?>
                    </div>

                </div>
                <div class="tab-pane fade" id="insulin-tab-pane" role="tabpanel" aria-labelledby="insulin-tab" tabindex="0">

                    <div class="row">
                        <div class="col">

                            <div class="row">
                                <div class="col">
                                    <a class="button-less" onclick="basalMod(-0.1);"></a><span class="pump_setting"><span class="basal_setting">0.0</span><span> U/hr</span></span><a class="button-more" onclick="basalMod(+0.1);"></a>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col">
                                    <a class="btn btn-lg btn-primary btn-setpump" onclick="sendBasal(basalCur); activeTab('home-tab');">Set basal rate</a>
                                </div>
                            </div>

                        </div>
                        <div class="col">

                            <div class="row">
                                <div class="col">
                                    <a class="button-less" onclick="bolusMod(-0.5);"></a><span class="pump_setting"><span class="bolus_setting">0.0</span><span> U</span></span><a class="button-more" onclick="bolusMod(+0.5);"></a>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col">
                                    <a class="btn btn-lg btn-primary btn-setpump" onclick="sendBolus(bolusCur); bolusMod(-10.0); activeTab('home-tab');">Dose bolus</a>
                                </div>
                            </div>

                        </div>
                    </div>

                </div>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="aboutModal" tabindex="-1" aria-labelledby="aboutModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="aboutModalLabel">About</h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
                <p style="font-size: 1.7em;"><img src="hp_scgms.png" style="width: 48px; height: 48px;"/> SmartCGMS</p>
                <p>Diabetic patient metabolism live demonstration project, created by SmartCGMS developer team.</p>
                <p>Copyright &copy; 2022</p>
                <p>This project (excluding the SmartCGMS architecture) was funded by a university-specific project PRVA-22-017.</p>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>

<script type="text/javascript">
$(document).ready(function() {
    connectToWS();

    setInterval(updateBackend, 700);
});

var basalCur = 0.0;

function basalMod(amt)
{
    basalCur += amt;
    if (basalCur < 0)
        basalCur = 0;
    else if (basalCur > 8.0)
        basalCur = 8.0;

    $('.basal_setting').text(basalCur.toFixed(1));
}

var bolusCur = 0.0;

function bolusMod(amt)
{
    bolusCur += amt;
    if (bolusCur < 0)
        bolusCur = 0;
    else if (bolusCur > 8.0)
        bolusCur = 8.0;

    $('.bolus_setting').text(bolusCur.toFixed(1));
}

function activeTab(tab){
    $('.nav-tabs button#' + tab).tab('show');
};
</script>

<script src="node_modules/bootstrap/dist/js/bootstrap.min.js"></script>

</body>
</html>
